
module.exports.Creer = function() {
	
	// Pour l'interne... 
	this.Liste = [];  
	this.Iterateur = null; 
	this.Verrou = false; 
	this.Passe = 100; 
	this._relancer = function(Obj) { 
		Obj.Passe = parseInt(Obj.Passe); 
		Obj.Passe = (Obj.Passe<100)?100:Obj.Passe; 
		if (Obj.Liste.length<1) 
			return false; 
		if (Obj.Verrou==true) 
			return false; 
		Obj.Verrou = true; 
		Obj.Iterateur = Obj.Liste.keys(); 
		process.nextTick( 
			Obj._parcourir, 
			Obj 
		); 
		return false; 
	}; 
	this._parcourir = function(Obj) { 
		if (Obj.Verrou!=true) 
			return false; 
		var i = Obj.Iterateur.next(); 
		if (i["done"]) { 
			Obj.Verrou = false; 
			return setTimeout( 
				Obj._relancer, 
				Obj.Passe, 
				Obj 
			); 
		} 
		var Id = i["value"]; 
		var f = Obj.Liste[Id]; 
		if (!f["Pause"]) { 
			var m = Date.now(); 
			if (m-f["Date"]>=f.Delais) { 
				f.Date = m; 
				f.FctRappel(f.Argu); 
			} 
		} 
		process.nextTick( 
			Obj._parcourir, 
			Obj 
		); 
	}; 
	
	// Pour l'utilisateur... 
	this.Ajouter = function(Delais,Fct,Argu) { 
		Delais = parseInt(Delais); 
		this.Liste.push({ 
			"Delais": (Delais<10)?10:Delais, 
			"Pause": false, 
			"Date": Date.now(), 
			"FctRappel": Fct, 
			"Argu": Argu  
		}); 
	}; 
	this.Pauser = function(Id,P) { 
		if (typeof this.Liste[Id]!="undefined") { 
			this.Liste[Id]["Pause"] = (P==true)?true:false; 
		} 
	}; 
	this.Terminer = function(Id) { 
		this.Verrou = false; 
		if (typeof this.Liste[Id]!="undefined") { 
			this.Liste.splice(Id,1); 
		} 
		this._relancer(this); 
	}; 
	this.Lancer = function() { 
		process.nextTick( 
			this._relancer, 
			this 
		); 
		return true; 
	}; 
}; 

